<?php

if (!defined('SMF'))
	die('Hacking attempt...');

function SMFbuy()
{
	//SMFbuy Actions
	$subActions = array(
		'bid' => 'NewBid',
		'adminset' => 'AdminSet',
		'manageadmin' => 'ManageAdmin',
		'closeitem' => 'CloseItem',
	);

	// Follow the sa or just go to main function
	@$sa = $_GET['sa'];
	if (!empty($subActions[$sa]))
		$subActions[$sa]();
	else
		fatal_lang_error('smfbuy_no_subact', false);
}

function CloseItem()
{
	global $db_prefix, $topic;

	if (allowedTo('admin_forum') || allowedTo('moderate_board'))
		db_query("UPDATE {$db_prefix}buy_items SET close = '1' WHERE ID_TOPIC = $topic", __FILE__, __LINE__);

	redirectexit('topic=' . $topic . '.0');
}

function ManageAdmin()
{
	global $context, $mbname, $txt;

	isAllowedTo('admin_forum');
	adminIndex('manage_smfbuy');
	loadTemplate('ManageSMFbuy');

	$context['page_title'] = $mbname . ' - ' . $txt['smfbuy'];
}

function AdminSet()
{
	global $scripturl;

	isAllowedTo('admin_forum');

	$smfbuy_maxdays = (int) $_REQUEST['smfbuy_maxdays'];
	$smfbuy_maxprice = (int) $_REQUEST['smfbuy_maxprice'];
	$smfbuy_maxshipping = (int) $_REQUEST['smfbuy_maxshipping'];

	updateSettings(array(
		'smfbuy_maxdays' => $smfbuy_maxdays,
		'smfbuy_maxprice' => $smfbuy_maxprice,
		'smfbuy_maxshipping' => $smfbuy_maxshipping,
	));

	redirectexit('action=smfbuy;sa=manageadmin');
}

function NewBid()
{
	global $modSettings, $db_prefix, $topic, $ID_MEMBER;

	isAllowedTo('smfbuy_offer');

	//You must be posting to *some* topic.
	if (empty($topic))
		fatal_lang_error('smf232', false);

	//Check bid
	$request = db_query("SELECT * FROM {$db_prefix}buy_items WHERE ID_TOPIC = $topic", __FILE__, __LINE__);
	$row = mysql_fetch_assoc($request);
	//check close
	if ( $row['close'] == 1 )
		fatal_lang_error('smfbuy_biderror3', false);
	else
	{
		//check date
		if ( (time() > ($row['date'] + (3600 * 24 * $row['days']))) && ($row['close'] == 0))
		{
			db_query("UPDATE {$db_prefix}buy_items SET close = '1' WHERE ID_TOPIC = $topic", __FILE__, __LINE__);
			fatal_lang_error('smfbuy_biderror3', false);
		}
		//check member
		elseif ( $row['ID_MEMBER'] == $ID_MEMBER )
			fatal_lang_error('smfbuy_biderror2', false);
		//check offer
		elseif ( $_POST['smfbuybid'] < $row['price'] )
			fatal_lang_error('smfbuy_biderror5', false);
		elseif ( $_POST['smfbuybid'] <= $row['bid'] )
			fatal_lang_error('smfbuy_biderror', false);
		elseif ( $_POST['smfbuybid'] > $modSettings['smfbuy_maxprice'] )
			fatal_lang_error('smfbuy_biderror6', false);
		//check max value --- close listing
		if ( $_POST['smfbuybid'] == $modSettings['smfbuy_maxprice'] )
			db_query("UPDATE {$db_prefix}buy_items SET bid = '" . $_POST['smfbuybid'] . "', ID_MEMBER_bid = '" . $ID_MEMBER . "', close ='1' WHERE ID_TOPIC = " . $topic, __FILE__, __LINE__);
		else
			db_query("UPDATE {$db_prefix}buy_items SET bid = '" . $_POST['smfbuybid'] . "', ID_MEMBER_bid = '" . $ID_MEMBER . "' WHERE ID_TOPIC = $topic", __FILE__, __LINE__);
	}

	redirectexit('topic=' . $topic . '.0');		
}

?>
